--[[Author:		DieenDieen 
-- global lookup
]]

local folder, core = ...
TaR = core --global table

-- local
title		= "TaR"
version		= GetAddOnMetadata(folder, "X-Curse-Packaged-Version") or ""
titleFull	= title.." "..version
packedtitle = "TaR";


TaRHistory={};
TaRRun=0;

local TaRFrame = false;
local TrackingEnabled = false;
-- Isolate the environment

core = LibStub("AceAddon-3.0"):NewAddon(packedtitle, "AceConsole-3.0",  "AceHook-3.0", "AceEvent-3.0") 

local regEvents = {
	"ADDON_LOADED",
	"UI_INFO_MESSAGE",
}

function StoreTrackedUnit (CurrentEvent,Target,TargetType)
if UnitExists(Target) and UnitIsUnit(Target,Target) then
   local guid = UnitGUID(Target);
   local unitX, unitY = GetPlayerMapPosition(Target);
   local unitclass, classFilename, unitrace, raceFilename, unitsex, unitname, unitrealm = GetPlayerInfoByGUID(guid);
   local unitspeed, groundSpeed, flightSpeed, swimSpeed = GetUnitSpeed(Target);
   
   if type(CurrentEvent[guid]) ~= "table" then CurrentEvent[guid] = {}; end;
   local CE = CurrentEvent[guid];
   if  type(CE.PovLevel) ~= "number" then CE.PovLevel = 0; end; 
   if CE.PovLevel<1 then
      CE.PovLevel = 1;
      CE.Guid = guid;
      CE.Name = unitname;
      if unitrealm=="" then CE.Realm =GetRealmName(); else CE.Realm = unitrealm; end;
      CE.Class = unitclass;
      CE.Race = unitrace;
      CE.Sex = unitsex;
      CE.Classification,CE.CreatureType,CE.CreatureFamily = UnitClassification(Target),UnitCreatureType(Target),UnitCreatureFamily(Target);
      CE.Target = UnitGUID(Target.."-target");
      CE.TargetFriendly = UnitIsFriend(Target, Target.."-target");

      CE.InCombat = UnitAffectingCombat(Target);
      CE.Health,CE.HealthMax = UnitHealth(Target),UnitHealthMax(Target);
      CE.X,CE.Y = GetPlayerMapPosition(Target);
      CE.Speed = unitspeed; 
      CE.Connected = UnitIsConnected(Target);
      CE.Corpse = UnitIsCorpse(Target);
      CE.Dead,CE.Ghost = UnitIsDead(Target),UnitIsGhost(Target);
      CE.FeignDeath = UnitIsFeignDeath(Target);
      CE.Player = UnitPlayerControlled(Target);
      CE.UsingVehicle = UnitUsingVehicle(Target);
      CE.Charmed = UnitIsCharmed(Target);
      CE.Possessed = UnitIsPossessed(Target);
      CE.Role = UnitGroupRolesAssigned(Target);
      
      if type(CE.Energies) ~= "table" then CE.Energies = {}; end;
      local CEE = CE.Energies;
         
      CEE.Mana,CEE.ManaMax = UnitPower(Target,SPELL_POWER_MANA),UnitPowerMax(Target,SPELL_POWER_MANA);
      CEE.Rage,CEE.RageMax = UnitPower(Target,SPELL_POWER_RAGE),UnitPowerMax(Target,SPELL_POWER_RAGE);
      CEE.Focus = UnitPower(Target,SPELL_POWER_FOCUS);
      CEE.Energy,CEE.EnergyMax = UnitPower(Target,SPELL_POWER_ENERGY),UnitPowerMax(Target,SPELL_POWER_ENERGY);
      CEE.RunicPower,CEE.RunicPowerMax = UnitPower(Target,SPELL_POWER_RUNIC_POWER),UnitPowerMax(Target,SPELL_POWER_RUNIC_POWER);
      CEE.SoulShards = UnitPower(Target,SPELL_POWER_SOUL_SHARDS); 
      CEE.HolyPower = UnitPower(Target,SPELL_POWER_HOLY_POWER);      
      CEE.Happiness = UnitPower(Target,SPELL_POWER_HAPPINESS);
      CEE.Eclipse = UnitPower(Target,SPELL_POWER_ECLIPSE);
      CEE.SpellHaste = UnitSpellHaste(Target);
       
      CE.Auras = {};
      local CEA = CE.Auras;
      for i=1,32 do
            local  auraname, aurarank, auraicon, auracount, auradispelType, auraduration, auraexpires, auracaster, auraisStealable, aurashouldConsolidate, auraspellID, auracanApplyAura, auraisBossDebuff, auravalue1, auravalue2, auravalue3 = UnitAura(Target, i);
	    if auraname ~= nil and auraname ~= "" then
		    local aura = {};
		    aura.Name = auraname;
		    aura.Rank = aurarank;
		    aura.Count = auracount;
		    aura.DispelType = auradispelType;
		    aura.Expires = auraexpires;
		    aura.Caster = auracaster;
		    aura.SpellID = auraspellID;
		    aura.BossDebuff = auraisBossDebuff;
		    tinsert(CEA,aura);
	      end;
         end;
      end;
      
   if TargetType=="player" then
      CE.PovLevel = 10;
      CE.Facing = GetPlayerFacing();
      CE.HasFullControl = HasFullControl();
      CE.Falling = IsFalling();
      CE.Mounted = IsMounted();
      CE.Stealthed = IsStealthed();
      CE.Swimming = IsSwimming();
      CE.ZoneName = GetRealZoneText();
      local MinDurability=1;
      for i=1,18 do
		 local current, maximum = GetInventoryItemDurability(i);
		 if current<maximum then MinDurability=math.min (MinDurability,current/maximum);end;
	      end;
      CE.MinDurability=MinDurability;
   end;
end;

function StoreTrackedEvent (TaRHistory)
local CurrentEvent={};

CurrentEvent.Time = GetTime();

StoreTrackedUnit (CurrentEvent,"player","player");
StoreTrackedUnit (CurrentEvent,"pet","pet");
StoreTrackedUnit (CurrentEvent,"focus","");
StoreTrackedUnit (CurrentEvent,"npc","");


for i=1,GetNumRaidMembers() do
   StoreTrackedUnit (CurrentEvent,"raid" .. i,"friendly");
   StoreTrackedUnit (CurrentEvent,"raid" .. i .."-target","");
   StoreTrackedUnit (CurrentEvent,"raid" .. i .."-pet","pet");
   StoreTrackedUnit (CurrentEvent,"raid" .. i .."-pet-target","");
   end

for i=1,GetNumPartyMembers() do
   StoreTrackedUnit (CurrentEvent,"party" .. i,"friendly");
   StoreTrackedUnit (CurrentEvent,"party" .. i .."-target","");
   StoreTrackedUnit (CurrentEvent,"party" .. i .."-pet","pet");
   StoreTrackedUnit (CurrentEvent,"party" .. i .."-pet-target","");
   end

for i=1,4 do
   StoreTrackedUnit (CurrentEvent,"boss" .. i,"boss");
   StoreTrackedUnit (CurrentEvent,"boss" .. i .."-target","");
   end;   
   tinsert(TaRHistory,CurrentEvent);
end

local UpdateTimerTotal = 0;
 
local function TaRonUpdate(self,elapsed)
   if TrackingEnabled then
       UpdateTimerTotal = UpdateTimerTotal + elapsed;
       if UpdateTimerTotal >= 0.1 then
           if type(TaRHistory[TaRRun]) ~= "table" then TaRHistory[TaRRun] = {}; end;
	   StoreTrackedEvent (TaRHistory[TaRRun]);
	   UpdateTimerTotal = 0;
	end;
     end;
end

function core:OnInitialize()
    self:RegisterChatCommand("tarcmd", "MySlashProcessorFunc");
    print ("tar started");	
end


function core:OnEnable()
   for i, event in pairs (regEvents) do 
		self:RegisterEvent(event)
	end	
end

function core:ADDON_LOADED(event, ...)
    if not TaRFrame then
       TaRFrame = CreateFrame("frame");
       TaRFrame:SetScript("OnUpdate", TaRonUpdate);
       end
    TaRRun = TaRRun + 1;
end


function core:UI_INFO_MESSAGE(event, ...)
local arg1 = ...;
end;


function core:OnDisable()
	
end


----------------------------------------------
function core:MySlashProcessorFunc(input)	--
----------------------------------------------
    if input=="" then
      print ("--- TaR "..version.." is running");
      print ("use start or stop to control tracking state");
      UpdateAddOnMemoryUsage();
      print ("atm uses "..GetAddOnMemoryUsage("TaR").." kb of memory");
      elseif strlower(input)=="start" then TrackingEnabled=true;
    elseif strlower(input)=="stop" then TrackingEnabled=false;
    end;
   if TrackingEnabled then
     print ("--- Tracking running");
     else
     print ("--- Tracking stopped");
     end;
end



